% $Id: BagOpsTest.oz,v 1.4 2010/09/21 18:46:52 leavens Exp $
\insert 'BagOps.oz'
\insert 'TestingNoStop.oz'
{System.showInfo ""}
{Show 'Since these tests use Assert, you will only see'}
{Show 'messages about what is being tested and failure messages if tests fail.'}
{StartTesting 'BagOps $Revision: 1.4 $'}
{Assert {Equal {AsBag nil} {EmptyBag}}}
{Assert {Equal {AsBag [3 1 2 3]} {AsBag [1 3 3 2]}}}
{Assert {Equal {AsBag [7 7 7 1]} {AsBag [7 1 7 7]}}}
{Assert {Not {Equal {AsBag [1 1]} {AsBag [1]}}}}
{Assert {Not {Equal {AsBag [c b]} {AsBag [c c b b]}}}}
{StartTesting 'Add'}
{Assert {Equal {Add {EmptyBag} 1 1} {AsBag [1]}}}
{Assert {Equal {Add {EmptyBag} 1 3} {AsBag [1 1 1]}}}
{Assert {Equal {Add {AsBag [2 3]} 1 6} {AsBag [1 1 1 1 1 1 2 3]}}}
{Assert {Equal {Add {AsBag [2 3 1]} 9 2} {AsBag [2 1 9 3 9]}}}
{StartTesting 'Multiplicity'}
{Assert {Multiplicity {AsBag [1 1 1 1 1 1 2 3]} 1} == 6}
{Assert {Multiplicity {AsBag [1 1 1 1 1 1 2 3]} 2} == 1}
{Assert {Multiplicity {AsBag [1 1 1 1 1 1 2 3]} 7} == 0}
{StartTesting 'Size'}
{Assert {Size {EmptyBag}} == 0}
{Assert {Size {AsBag [2 1 3 1 1]}} == 5}
{Assert {Size {AsBag [2 3 1 5 7 4 4 4 4]}} == 9}
{StartTesting 'Remove'}
{Assert {Equal {Remove {EmptyBag} 7 900} {EmptyBag}}}
{Assert {Equal {Remove {AsBag [2 1 3 1 1]} 1 2} {AsBag [1 3 2]}}}
{Assert {Equal {Remove {AsBag [2 3 1 5 7 4]} 5 2} {AsBag [3 2 1 7 4]}}}
{Assert {Equal {Remove {AsBag [2 2 2 1 2]} 2 3} {AsBag [2 1]}}}
{StartTesting 'Union'}
{Assert {Equal {Union {EmptyBag} {AsBag [d d e]}} {AsBag [d d e]}}}
{Assert {Equal {Union {AsBag [a a b c]} {EmptyBag}} {AsBag [a a b c]}}}
{Assert {Equal {Union {AsBag [a a a b]} {AsBag [a b b b e]}}
         {AsBag [a a a a b b b b e]}}}
{Assert {Equal {Union {AsBag [e a b c]} {AsBag [c d e a]}}
         {AsBag [a a b c c d e e]}}}
{StartTesting 'Minus'}
{Assert {Equal {Minus {EmptyBag} {AsBag [d d e]}} {EmptyBag}}}
{Assert {Equal {Minus {AsBag [d d e]} {EmptyBag}} {AsBag [d d e]}}}
{Assert {Equal {Minus {AsBag [a a b c c]} {AsBag [a b]}} {AsBag [a c c]}}}
{Assert {Equal {Minus {AsBag [n b c a b c]} {AsBag [a b c]}} {AsBag [n b c]}}}
{Assert {Equal {Minus {AsBag [c b s b i]} {AsBag [b b]}} {AsBag [c s i]}}}
{Assert {Equal {Minus {AsBag [x y z]} {AsBag [b a]}} {AsBag [x y z]}}}
{StartTesting 'Intersect'}
{Assert {Equal {Intersect {EmptyBag} {AsBag [d e]}} {EmptyBag}}}
{Assert {Equal {Intersect {AsBag [a b c]} {AsBag [d e]}} {EmptyBag}}}
{Assert {Equal
         {Intersect {AsBag [e a a b c]} {AsBag [c d a e]}} {AsBag [e a c]}}}
{Assert {Equal
         {Intersect {AsBag [e e e a a]} {AsBag [e e a x]}}
         {AsBag [e e a]}}}
{Assert {Equal {Intersect {AsBag [a a b]} {AsBag [b a a]}} {AsBag [a a b]}}}
{StartTesting 'UnionOfAll'}
{Assert {Equal {UnionOfAll nil} {EmptyBag}}}
{Assert {Equal
         {UnionOfAll [{AsBag [a a b x c]} {AsBag nil} {AsBag [a d e]}]}
         {AsBag [a a a b x c d e]}}}
{Assert {Equal
         {UnionOfAll [{AsBag [a]} {AsBag [b c]} {EmptyBag} {AsBag [d e]}
                     {AsBag [f g h i j]} {AsBag [k l m a b e]}]}
         {AsBag [a a b b c d e e f g h i j k l m]}}}
{StartTesting 'done'}
